# Contributing

Contributions are **welcome** and will be fully **credited**.

We accept contributions via Pull Requests on [Github](https://github.com/shieldfy/API-Security-Checklist).


## Pull Requests

- **Sync** - Please make sure your repository is up to date with ours to avoid conflicts as much as possible.
- **Language** - Please make sure to check your contribution for grammar mistakes and typos as much as possible.
- **One pull request per feature** - If you want to do more than one thing, send multiple pull requests.
- **Send coherent history** - Make sure each individual commit in your pull request is meaningful. If you had to make multiple intermediate commits while developing, please [squash them](http://www.git-scm.com/book/en/v2/Git-Tools-Rewriting-History#Changing-Multiple-Commit-Messages) before submitting.

## Add New Translation
- Fork the repository.
- Translate the `README.md` file.
- write the translations to a new file with naming schema (`README-[Language-code].md`), [Available languages codes](https://en.wikipedia.org/wiki/List_of_ISO_639-1_codes).
*Example: If you want to translate for Deutsch, you would name the translated readme file as `README-de.md`.*

**Stay Secure**!
